/** 
 * Library of static mathematical functions
 * useful for Project Euler.
 *
 *   - gcfLong - return greatest common factor of a and b
 *   - triangleLong - return nth triangle number
 *   - isPalindrome - classic palindrome check
 *   - reverse - classic String reverse
 */
public class EulerLib { 

	/** Return the nth triangular number. */
	public static long triangleLong(long n) { 
		long tri = (n*(n+1))/2;
		return tri;
	}

	/** Perform the Euclidean algorithm to find the greatest common factor between a and b. */
	public static long gcfLong(long a, long b) {
		long t;
		while(b!=0) { 
			t = b;
			b =  a%b;
			a = t;
		}
		return a;
	}
}
