import java.util.Set;
import java.util.HashSet;

/**
 * Multiples of 3 and 5.
 *
 * If we list all the natural numbers below 10 that are multiples of 3 or 5, we get 3, 5, 6 and 9. The sum of these multiples is 23.
 * Find the sum of all the multiples of 3 or 5 below 1000.
 * */
public class Problem001 implements EulerSolution {

	public String run() {
		// Maximum
		int max = 1000;
		
		// Multiples list
		int[] multiplesList = {3,5};
		
		// Results set
		Set<Integer> s = new HashSet<Integer>();

		// From 1 up to and including (max-1)/multiple (not max/multiple-1)
		for(int m=0; m<multiplesList.length; m++) { 
			int multiple = multiplesList[m];
			for(int i=1; i<=((max-1)/multiple); i++) { 
				int num = i*multiple;
				s.add(num);
			}
		}
		
		// Sum them all up
		int sum = 0;
		for(Integer i : s) { 
			sum += i;
		}
		
		return Integer.toString(sum);
	}

}

