/** 
 * Pythagorean Triplet that sums to 1000.
 *
 * Pythagorean triplets a < b < c have property that 
 * a^2 + b^2 = c^2
 *
 * 3^2 + 4^2 = 9 + 16
 *           = 25
 *			 = 5^2
 *
 * Find the Pythagorean triplet such that a + b + c = 1000.
 *
 *
 * Solving
 * x + y + z - 1000 = 0
 * x^2 + y^2 - z^2 = 0
 *
 * Intersection of cone and plane 
 * 
 * x < 1000
 *
 * y = ( 1000 * (x-500) ) / ( x - 1000) 
 *
 * z = - x - y + 1000
 *
 * See which of these numbers yield integers.
 * We know x will be an integer,
 * we know z will be an integer,
 * as long as y is an integer.
 *
 * That boils down to, will y be an integer?
 * When will 
 * (1000*(500 - x))
 * be perfectly divisible by 
 * (1000-x
 *
 * 500*((1000 - x) - x)
 * ------------
 * ( 1000 - x ) 
 *
 *
 * Check if a double is an int: (d % 1) == 0
 */

public class Problem009 implements EulerSolution {

	public String run() { 
		for(int a = 999; a>0; a--) { 
			for(int b = 1000 - a; b>0; b--) { 
				double c1 = Math.sqrt(a*a+b*b);
				if(c1%1==0) { 
					// integer, candidate
					int c2 = 1000 - (a+b);
					if(Math.abs(c2-c1)/c2<0.00001) { 
						// bingo
						//System.out.println("------------------");
						//System.out.println("c1 = "+c1+" c2 = "+c2);
						//System.out.println("a^2 + b^2 = c^2");
						//System.out.println(a+"^2 + "+b+"^2 = "+c2+" ^2");
						//System.out.println((a*a)+" + "+(b*b)+" = "+(c2*c2));
						//System.out.println("a + b + c = " + a + " + " + b + " + " + c2 + " = " + (a+b+c2));
						//System.out.println("abc = "+(a*b*c2));
						return new Integer(a*b*c2).toString();
					}
				}
			}
		}
		return "";
	}





	public static void old() { 
		for(int x = 999; x>0; x--) { 
			double y = (1000*(x-50))/(x-1000);
			if(y%1==0) { 
				System.out.println(x);
				System.out.println(y);
			}
			//int z = 1000 - x - y;

			// if x and y and z are all ints,
			// then they satisfy the equations
			// and are the single pythagorean triplet 
			// of interest.
		}
	}

}
