import java.math.BigInteger;

/** Powerful Digit Sum.
 *
 * We wish to know the maximum digital sum
 * for the numbers a^b for a,b < 100.
 *
 * Strategy: brute force. Only 100^2.
 */

public class Problem056 implements EulerSolution {

	public String run() { 
		int maxSum = 0;
		int maxA = 0;
		int maxB = 0;
		for(int a=1; a<100; a++) {
			for(int b=1; b<100; b++) { 
				BigInteger x = new BigInteger( Integer.toString(a) );
				x = x.pow(b);
				int sum = computeDigitalSum(x);
				if(sum>maxSum) {
					maxSum = sum; maxA = a; maxB = b;
				}
			}
		}
		return Integer.toString(maxSum);
	}

	public static int computeDigitalSum(BigInteger n) { 
		char[] s = n.toString().toCharArray();
		int runningSum = 0;
		for(int i=0; i<s.length; i++) {
			int digit = Character.digit(s[i],10);
			runningSum += digit;
		}
		return runningSum;
	}
}

