import java.math.BigInteger;

/** Factorial Sum of Digits.
 *
 * This class splits a given integer into its digits,
 * then computes the sum of the factorials of the digits.
 * If the two are equal, it reports the number.
 */
public class Factorials {

	public static void main(String[] args) { 

		for(int i=3; i<100000000; i++) { 
			if(i==sumFactorialDigits(i)) {
				System.out.println(i);
			}
		}
	}

	/** Compute the sum of the factorials of the digits of a number n. */
	public static int sumFactorialDigits(int n) {
		int sum = 0;
		char[] digits = Integer.toString(n).toCharArray();
		for(int i=0; i<digits.length; i++) { 
			char d = digits[i];
			int di = Character.digit(d,10);
			sum += factorial(di);
		}
		return sum;
	}

	/** Compute the factorial of n. */
	public static int factorial(int n) { 
		if(n==0||n==1) { 
			return 1;
		} else { 
			return n*factorial(n-1);
		}
	}
}