import java.util.*;

public class Problem002Misread {


	public static void main(String[] args) { 
		Integer sum;
		
		//sum = doIt(10);
		//if(sum!=(2+5)) {
		//	throw new RuntimeException("Test error with input 10.");
		//}

		//sum = doIt(100);
		//if(sum!=(2+5+13+34+89)) {
		//	throw new RuntimeException("Test error with input 100.");
		//}

		sum = doIt(4000000);
		System.out.println(sum);

	}

	public static Integer doIt(Integer max) { 

		Map<Integer,Integer> memo = new TreeMap<Integer,Integer>();

		// First, get the last Fibonacci number above max.
		Integer k = maxFib(max, memo);

		System.out.println("Last Fibonacci number up to " + max + " is:");
		System.out.println("F("+k+") = " + memo.get(k));

		// Second, sum up all even Fibonacci numbers below the kth one.
		Integer sum = evenFib(k, memo); 

		System.out.println("Sum of even Fibonacci numbers up to F("+(k)+") is:");
		System.out.println(sum);
		return sum;
	}

	/** Compute the last kth Fibonacci number not exceeding max.
	 *
	 * Returns k. F(k) is contained in the map memo.
	 * F(k) < max.
	 *
	 * This uses the numbering of the 0, 1, 2, 3, 4, 5 Fib numbers:
	 *
	 * 1, 1, 2, 3, 5, 8 ...
	 *
	 * */
	public static Integer maxFib(Integer max, Map<Integer, Integer> memo) { 

		if(max<1) { 
			throw new IllegalArgumentException("Max must be 1 or more.");
		} else if(max<2) { 
			return 1;
		}

		Integer Fkm2 = 1; // F(0) = 1
		Integer Fkm1 = 1; // F(1) = 1
		Integer Fk = Fkm1 + Fkm2; // F(2) = 2

		memo.put(0,1);
		memo.put(1,1);
		memo.put(2,2);
		//System.out.println("Saving F(2) = 2");

		Integer Fkp1 = Fk + Fkm1; // F(3)

		// Starts at 2. In the first loop, k=3.
		Integer k = 2;

		while(Fkp1<max) {
			// Advance by one
			k++;

			Fkm2 = Fkm1;
			Fkm1 = Fk;
			Fk = Fkp1;

			//System.out.println("Saving F("+k+") = "+Fk);
			memo.put(k, Fk);

			// Peek again
			Fkp1 = Fk + Fkm1;
		}
		if(Fk>max) { 
			throw new IllegalStateException("Fk should be less than max.");
		}

		// Fk is the fibonacci number we want to return,
		// but instead we return k,
		// and the let the user look up Fk in memo.
		return k;
	}


	/** Return the nth Fibonacci number. */
	public static Integer fib(Integer n, Map<Integer,Integer> memo) { 
		if(memo.keySet().contains(n)) { 
			return memo.get(n);
		}
		Integer maxKey = Collections.max(memo.keySet());
		Integer k = 0;
		Integer Fk = 0;
		while(maxKey < n) { 
			k = maxKey+1;
			Fk = memo.get(k-2) + memo.get(k-1);
			memo.put(k,Fk);
		}
		return Fk;
	}


	public static Integer evenFib(Integer k, Map<Integer, Integer> memo) { 
		// compute the sum of the even Fibonacci numbers
		// up to Fibonacci number k, F_k.
		//
		//for(int im=0; im <= (k-1)/2; im++) { 
		Integer evenSum = 0;
		System.out.println("Even fib: k = "+k);
		for(int im=0; im <= k/2; im++) { 
			Integer F_2m = memo.get(2*im);
			evenSum += F_2m;
			System.out.println("    im = "+im+" F(k) = F(" + (2*im) + ") = " + F_2m + " evenSum = "+evenSum);
		}
		return evenSum;
	}




	/*
	public static Integer evenFib2(Integer k, Map<Integer, Integer> memo) { 
		// If we want to find all the Fibonacci numbers up to the 2m th Fib #,
		// We are adding up m even terms.
		Integer m = k/2;
		Integer evenSum = 0;
		//System.out.println("Summing "+m+" even Fibonacci numbers.");
		for(int im = 0; im < (k/2); im++) {
			// Note,above needs to be im < (k/2)
			// so that last even sum we include is 2(m-1) or 2m-2
			//System.out.println("Looking for "+(2*im)+" in set:");
			//System.out.println(memo.keySet());
			evenSum += (m+1-im)*memo.get(2*im);
		}

		return evenSum;
	}
	*/

}



