/**
 * 10,001st Prime.
 *
 * By listing the first six prime numbers: 2, 3, 5, 7, 11, and 13, we can see that the 6th prime is 13.
 *
 * What is the 10 001st prime number?
 */
public class Problem007 { 

	/** Main method: run the prime sieve with a large enough input 
	 * that we expect at least 10,001 prime numbers.
	 * (For that, use the pi function pi(x) or approx. pi(x) ~ x / ln(x) )
	 */
	public static void main(String[] args) { 
		primeSieve(200000);
	}

	/** Run the Sieve of Eratosthenes prime number sieve,
	 * and find at least 10,001 prime numbers.
	 */
	public static void primeSieve(int n) { 

        // initially assume all integers are prime 
        boolean[] isPrime = new boolean[n+1];
        for (int i = 2; i <= n; i++) {
            isPrime[i] = true;
        }

        // mark non-primes <= n using Sieve of Eratosthenes
        for (int factor = 2; factor*factor <= n; factor++) {

            // if factor is prime, then mark multiples of factor as nonprime
            // suffices to consider mutiples factor, factor+1, ...,  n/factor
            if (isPrime[factor]) {
                for (int j = factor; factor*j <= n; j++) {
                    isPrime[factor*j] = false;
                }
            }
        }

		// get 10,001st prime
		int primes = 0;
		for(int i=2; i<=n; i++) { 
			if(isPrime[i]) { 
				primes++;
			}
			if(primes==10001) { 
				System.out.println("10,001st prime: "+i);
				break;
			}
		}
	}
}
