import java.util.List;
import java.util.LinkedList;
import java.util.ArrayList;

/** Sum of Primes Below 2 Million.
 */
public class Sum { 

	public static void main(String[] args) { 
		int TWO_MILLION = 2000000;
		List<Long> primes = primeSieve(TWO_MILLION);
		Long sum = sumList(primes);
		System.out.println(sum);
	}

	/** Sum up all the elements in a list and return it. */
	public static Long sumList(List<Long> list) {
		Long sum = new Long(0);
		for(Long i : list) { 
			sum += i;
		}
		return sum;
	}

	/** Find all prime numbers below n.
	 */
	public static List<Long> primeSieve(int n) { 

        // initially assume all integers are prime 
        boolean[] isPrime = new boolean[n+1];
        for (int i = 2; i <= n; i++) {
            isPrime[i] = true;
        }

        // mark non-primes <= n using Sieve of Eratosthenes
        for (int factor = 2; factor*factor <= n; factor++) {

            // if factor is prime, then mark multiples of factor as nonprime
            // suffices to consider mutiples factor, factor+1, ...,  n/factor
            if (isPrime[factor]) {
                for (int j = factor; factor*j <= n; j++) {
                    isPrime[factor*j] = false;
                }
            }
        }

		// Add primes to list
		ArrayList<Long> primes = new ArrayList<Long>();
		int nprimes = 0;
		for(int k=2; k<=n; k++) {
			if(isPrime[k]) { 
				primes.add( new Long(k) );
				nprimes++;
			}
		}

		return primes;
	}
}








