import java.math.BigInteger;

public class BOP {

	public static final int DEG = 10;

	public static void main(String[] args) { 
		// Should be....... a big number
		realBOPs();
	}


	///////////////////////////////////////


	/** Solve the real problem. */
	public static void realBOPs() { 
		BigInteger sum = BigInteger.ZERO;
		// Generate polynomials of degree k-1,
		// where k = 1 to degree of generating function
		for(int k=1; k<=DEG; k++) { 
			for(int n = k+1; n<(DEG+2); n++ ) {
				long realTerm = generatingFunction(n);
				long estimatedTerm = optimumPolynomial(k,n);

				//System.out.println(realTerm);
				//System.out.println(estimatedTerm);
				//System.out.println();

				if(realTerm != estimatedTerm){
					sum = sum.add(new BigInteger(Long.toString(estimatedTerm)));
					break;
				}
			}
		}
		System.out.println(sum);
	}



	///////////////////////////////////////


	/** Return value of generating function y(n) = n^3 at n. */
	public static long cubicGeneratingFunction(int n) { 
		return (long)Math.pow(n,3);
	}


	/** Return value of generating function y(n) 
	 * (10th degree generating polynomial
	 * from problem statement).
	 * */
	public static long generatingFunction(int n) { 
		long sum = 0;
		long negn = (long)(-n);
		for(int i=0; i<=DEG; i++) { 
			sum += Math.pow(negn,i);
		}
		return sum;
	}



	///////////////////////////////////////


	/** Optimum polynomial value for k, n. */
	public static long optimumPolynomial(int k, int n) { 
		// Using Lagrange interpolation
		// y_i = data y values (come from generating function)
		// x_i = data x values (integers)
		// l_i = lagrange basis function
		//
		// L(n) = sum_{j=0}^{k} y_j(n) l_j(n)
		//
		// l_j(n) = \prod_{0 \leq m \leq k, m \neq k} \frac{ n - n_m) }{ n_j - n_m }
		//
		//  or, simplifying,
		//
		// l_j(n) = \prod_{0 \leq m \leq k, m \neq k} \frac{ n - m) }{ j - m }

		// This should generate 58 for n^3, k=3, 
		// but it does not.
		long Ln = 0; // value of optimum Lagrange polynomial at location n
		for(int j=1; j<=k; j++) { 
			long yj = generatingFunction(j);
			long ljNum = 1;
			long ljDenom = 1;
			for(int m=1; m<=k; m++){
				if(m!=j) { 
					// I got stuck a really long time, because of the next step:
					ljNum   *= (n-m);
					ljDenom *= (j-m);
					// lj *= (1.0*(n-m))/(j-m); // <-- this was the culprit. these are fractions.
				}
			}
			Ln += (yj*ljNum)/ljDenom;
		}
		return Ln;
	}


}