import java.util.Map;
import java.util.TreeMap;
import java.util.List;
import java.math.BigInteger;

public class Ordering {

	public static void main(String[] args) { 
		test();
	}

	public static void test() {
		// We will run 1000 sets of unique primes,
		// evaluating each of the 11 (?) expressions
		// that can lead to 64 total factors.
		//
		// M is the number of primes we are looking at.
		// G is the number of generating expressions.
		//
		int BIG = 1000;
		int M = 6;
		int G = 11;


		List<Long> primes = Sieve.primeSieve( (int)(BIG) );

		// Too confusing to re-index by 0 at this point.
		BigInteger[] ps = new BigInteger[M+1];
		//BigInteger[] gs = new BigInteger[G];

		String[] labels = {"p1 p2 p3 p4 p5 p6",
							"p1^3 p2 p3 p4 p5",
							"p1^7 p2 p3 p4",
							"p1^15 p2 p3",
							"p1^31 p2",
							"p1^63",
							"p1^3 p2^3 p3 p4",
							"p1^3 p2^3 p3^3",
							"p1^7 p2^3 p3",
							"p1^7 p2^7",
							"p1^15 p2^3"};

		// Save primes later, if we need to
		TreeMap<BigInteger,String> lookup = new TreeMap<BigInteger,String>();
		TreeMap<String,Integer> minimumCount = new TreeMap<String,Integer>();

		for(int j=0; j<M; j++) {
			ps[j+1] = BigInteger.valueOf(primes.get(j));
		}

		BigInteger ps13 = ps[1].pow(3); // memoize
		BigInteger ps23 = ps[2].pow(3);
		BigInteger ps17 = ps[1].pow(7);
		BigInteger ps115 = ps[1].pow(15);


		lookup.put( ps[1].multiply(ps[2]).multiply(ps[3]).multiply(ps[4]).multiply(ps[5]).multiply(ps[6]),
					labels[0]);

		lookup.put( ps13.multiply( ps[2]).multiply(ps[3]).multiply(ps[4]).multiply(ps[5]),
					labels[1]);

		lookup.put( ps17.multiply( ps[2]).multiply(ps[3]).multiply(ps[4]),
					labels[2]);

		lookup.put( ps115.multiply(ps[2]).multiply(ps[3]),
					labels[3]);

		lookup.put( ps[1].pow(31).multiply(ps[2]),
					labels[4]);

		lookup.put( ps[1].pow(63),
					labels[5]);

		lookup.put( ps13.multiply( ps23 ).multiply(ps[3]).multiply(ps[4]),
			labels[6]);

		lookup.put( ps13.multiply( ps23 ).multiply( ps[3].pow(3) ),
			labels[7]);
		
		lookup.put( ps17.multiply( ps23 ).multiply(ps[3]),
			labels[8]);
		
		lookup.put( ps17.multiply( ps[2].pow(7) ),
			labels[9]);
		
		lookup.put( ps115.multiply( ps23 ),
			labels[10]);

		// And now, we sort.
		// Just kidding. Already sorted.

		//System.out.println("------------------------------------------------");
		//System.out.println("64-Factor Generating Expressions in Sorted Order:");
		//System.out.println("Prime low = "+ps[1]+", Prime hi = "+ps[M]);
		//System.out.println();

		boolean firstTime = true;
		for(String genlabel : lookup.values() ) {
			Integer min = new Integer(1);
			if(firstTime) { 
				if(minimumCount.containsKey(genlabel)) {
					min = minimumCount.get(genlabel);
					min = min + 1;
					minimumCount.put(genlabel,min);
				} else {
					minimumCount.put(genlabel,min);
				}
				firstTime = false;
				break;
			}
		}
		System.out.println(minimumCount);
			
	}

	public static long longpow(long a, int b) {
		long product = 1;
		for(int j=0; j<b; j++) { 
			product = (product*a)%500000000;
		}
		return product;
	}
}
