import java.math.BigInteger;
import java.util.List;
import java.util.ArrayList;
import java.util.Set;
import java.util.HashSet;
import java.util.BitSet;

public class BigDivisors { 
	
	public static final long MAX = (long)(1E6);

	public static void main(String[] args) { 
		solve();
	}

	/////////////////////////////////////

	public static void solve() {

		BigInteger max = BigInteger.valueOf(MAX);

		int eightFactors = 0;

		PrimeGenerator pg1 = new PrimeGenerator(max);
		PrimeGenerator pg2 = new PrimeGenerator(max);
		PrimeGenerator pg3 = new PrimeGenerator(max);


		while(pg1.hasNext()) { 
			BigInteger p1 = pg1.next(); 
			while(pg2.hasNext()) { 
				BigInteger p2 = pg2.next(); 
				while(pg3.hasNext()) { 
					BigInteger p3 = pg3.next(); 

					BigInteger product = p1.multiply(p2).multiply(p3);

					if(product.compareTo(max) <= 0) {
						System.out.println(product+" = "+p1+"*"+p2+"*"+p3);
						eightFactors++;
					} else {
						break;
					}
				}
			}
		}

		//for(int iA=0; iA<primes.size(); iA++) { 
		//	BigInteger pA = BigInteger.valueOf( primes.get(iA) );
		//	for(int iB=iA+1; iB<primes.size(); iB++) { 

		//		BigInteger pB = BigInteger.valueOf( primes.get(iB) );

		//		BigInteger productA = pA.pow(3).multiply(pB);
		//		if(productA.compareTo(max) <= 0) { 
		//			System.out.println(productA+" = "+pA+"^3*"+pB);
		//			eightFactors++;
		//		}

		//		BigInteger productB = pB.pow(3).multiply(pA);
		//		if(productB.compareTo(max) <= 0 && productB.compareTo(productA)!=0 ) { 
		//			System.out.println(productB+" = "+pB+"^3*"+pA);
		//			eightFactors++;
		//		}
		//		
		//		if(productA.compareTo(max)>0 && productB.compareTo(max)>0) { 
		//			break;
		//		}
		//	}
		//}

		//for(int iM=0; iM<primes.size(); iM++) { 
		//	BigInteger pM = BigInteger.valueOf( primes.get(iM) );
		//	BigInteger productM = pM.pow(7);
		//	if(productM.compareTo(max)<=0) { 
		//		eightFactors++;
		//	} else {
		//		break;
		//	}
		//	
		//}

		System.out.println(eightFactors);

	}

	/////////////////////////////////////


	/** Because we're dealing with prime numbers up to 1 trillion,
	 * the usual Sieve of Eratosthenes algorithm will puke
	 * b/c it needs 10s of GBs of memory.
	 *
	 * Instead, we need a prime generator.
	 */


}

