import java.util.List;
import java.util.ArrayList;

public class Divisors { 
	
	public static final long MAX = (long)(1000);

	public static void main(String[] args) { 
		solve();
	}

	public static void solve() { 
		List<Long> primes = primeSieve((int)MAX/2);
		int eightFactors = 0;

		// Count up all primes of the form p1*p2*p3
		long p1, p2, p3;
		for(int i1=0; i1<primes.size(); i1++) { 
			p1 = primes.get(i1);
			for(int i2=i1+1; i2<primes.size(); i2++) { 
				p2 = primes.get(i2);
				for(int i3=i2+1; i3<primes.size(); i3++) {
					p3 = primes.get(i3);
					long prod = p1*p2*p3;
					if(p1*p2*p3<=MAX) { 
						System.out.println(prod+" = "+p1+"*"+p2+"*"+p3);
						eightFactors++;
					} else {
						break;
					}
				}
			}
		}

		// Count up all primes of the form pA^3 * pB
		long pA = 1, pB = 1;
		for(int iA=0; iA<primes.size(); iA++){ 
			for(int iB=iA+1; iB<primes.size(); iB++) { 

				pA = primes.get(iA);
				pB = primes.get(iB);

				long prod1 = (long)(Math.pow(pA,3))*pB;
				long prod2 = (long)(Math.pow(pB,3))*pA;

				boolean pA3good = prod1 <= MAX;
				boolean pB3good = prod2 <= MAX;

				if(pA3good) {
					System.out.println(prod1+" = "+pA+"^3*"+pB);
					eightFactors++;
				}
				if(pB3good) { 
					System.out.println(prod2+" = "+pB+"^3*"+pA);
					eightFactors++;
				}
			}
		}

		System.out.println(eightFactors);
				

	}

	/** Find all prime numbers below n.
	 */
	public static List<Long> primeSieve(int n) { 

        // initially assume all integers are prime 
        boolean[] isPrime = new boolean[n+1];
        for (int i = 2; i <= n; i++) {
            isPrime[i] = true;
        }

        // mark non-primes <= n using Sieve of Eratosthenes
        for (int factor = 2; factor*factor <= n; factor++) {

            // if factor is prime, then mark multiples of factor as nonprime
            // suffices to consider mutiples factor, factor+1, ...,  n/factor
            if (isPrime[factor]) {
                for (int j = factor; factor*j <= n; j++) {
                    isPrime[factor*j] = false;
                }
            }
        }

		// Add primes to list
		ArrayList<Long> primes = new ArrayList<Long>();
		int nprimes = 0;
		for(int k=2; k<=n; k++) {
			if(isPrime[k]) { 
				primes.add( new Long(k) );
				nprimes++;
			}
		}

		return primes;
	}
}
