import java.util.List;
import java.util.ArrayList;
import java.util.Set;
import java.util.HashSet;

public class Reset { 
	
	public static final int MAX = 10000;
	public static final int MAXPRIME = 10000;

	public static void main(String[] args) { 
		solve();
	}

	/////////////////////////////////////

	public static void solve() {
		List<Long> primes = primeSieve(MAXPRIME);


		Set<Long> tripleProducts = new HashSet<Long>();
		Set<Long> cubeProducts = new HashSet<Long>();
		Set<Long> allProducts = new HashSet<Long>();


		int eightDivisors = 0;
		int eightDivisors_cube = 0;
		int eightDivisors_triple = 0;
		

		// Cube product
		for(int iA=0; iA<primes.size(); iA++){
			long pA = primes.get(iA);
			for(int iB=iA+1; iB<primes.size(); iB++){
				if(iA==iB) { 
					continue;
				}
				long pB = primes.get(iB);

				long prod1 = pA*pA*pA*pB;
				long prod2 = pB*pB*pB*pA;
				if(prod1<=MAX) {

					cubeProducts.add(prod1);
					if(allProducts.contains(prod1)) {
						System.out.println("Duplicate product: "+prod1+" = "+pA+"^3*"+pB);
					} else {
						allProducts.add(prod1);
					}

					System.out.printf("%d = %d^3*%d \n",prod1,pA,pB);
					eightDivisors++;
				}
				if(prod2<=MAX) {

					cubeProducts.add(prod2);
					if(allProducts.contains(prod2)) {
						System.out.println("Duplicate product: "+prod2+" = "+pA+"^3*"+pB);
					} else {
						allProducts.add(prod2);
					}

					System.out.printf("%d = %d^3*%d \n",prod2,pB,pA);
					eightDivisors++;
				}

			}
		}


		eightDivisors_cube = eightDivisors;



		// Triple product
		long tripleProduct = 1;
		for(int i1=0; i1<primes.size(); i1++) {
			long p1 = primes.get(i1);

			for(int i2=i1; i2<primes.size(); i2++) { 
				if(i2==i1) { 
					continue;
				}

				long p2 = primes.get(i2);

				for(int i3=i2; i3<primes.size(); i3++){
					if(i3==i2 || i3==i1) { 
						continue;
					}
					long p3 = primes.get(i3);

					long prod = p1*p2*p3;
					if(prod<=MAX) { 

						tripleProducts.add(prod);
						if(allProducts.contains(prod)) {
							System.out.println("Duplicate product: "+prod+" = "+p1+"*"+p2+"*"+p3);
						} else {
							allProducts.add(prod);
						}

						System.out.printf("%d = %d*%d*%d \n",prod,p1,p2,p3);
						eightDivisors++;
					}
				}
			}
		}

		eightDivisors_triple = eightDivisors - eightDivisors_cube;

		System.out.println("Divisors contributed by cube products:");
		System.out.println(eightDivisors_cube);
		System.out.println(cubeProducts.size());

		System.out.println("Divisors contributed by triple products:");
		System.out.println(eightDivisors_triple);
		System.out.println(tripleProducts.size());

		System.out.println("Divisors total:");
		System.out.println(eightDivisors);
		System.out.println(allProducts.size());


	}

	/////////////////////////////////////


	/** Find all prime numbers below n.
	 */
	public static List<Long> primeSieve(int n) { 

        // initially assume all integers are prime 
        boolean[] isPrime = new boolean[n+1];
        for (int i = 2; i <= n; i++) {
            isPrime[i] = true;
        }

        // mark non-primes <= n using Sieve of Eratosthenes
        for (int factor = 2; factor*factor <= n; factor++) {

            // if factor is prime, then mark multiples of factor as nonprime
            // suffices to consider mutiples factor, factor+1, ...,  n/factor
            if (isPrime[factor]) {
                for (int j = factor; factor*j <= n; j++) {
                    isPrime[factor*j] = false;
                }
            }
        }

		// Add primes to list
		ArrayList<Long> primes = new ArrayList<Long>();
		int nprimes = 0;
		for(int k=2; k<=n; k++) {
			if(isPrime[k]) { 
				primes.add( new Long(k) );
				nprimes++;
			}
		}

		return primes;
	}
}
